
def define(FILENAME_EXTENSION,
           BLANKLINE,
           INLINE_TAGS_SUBST,
           CODE,
           LIST,
           ARGLIST,
           TABLE,
           FIGURE_EXT,
           INTRO,
           OUTRO):
    # all arguments are dicts and accept in-place modifications (extensions)

    FILENAME_EXTENSION['st'] = '.st'
    BLANKLINE['st'] = '\n'
    # replacement patterns for substitutions of inline tags
    INLINE_TAGS_SUBST['st'] = {
        # keep math as is:
        'math':      None,  # indicates no substitution
        'math2':     r'\g<begin>\g<puretext>\g<end>',
        'emphasize': None,
        'bold':      r'\g<begin>**\g<subst>**\g<end>',
        'verbatim':  r"\g<begin>'\g<subst>'\g<end>",
        'label':     r'\g<subst>',
        'reference': r'\g<subst>',
        'linkURL':   r'\g<begin>"\g<url>":\g<link>\g<end>',
        'plainURL':  r'\g<begin>"\g<url>":\g<url>\g<end>',
        # the replacement string differs, depending on the match object m:
        'section':       r'\g<subst>',
        'subsection':    r'\g<subst>',
        'subsubsection': r'\g<subst>',
        'paragraph':     r'*\g<subst>* ',  # extra blank
        'title':         r'TITLE: \g<subst>',
        'date':          r'DATE: \g<subst>',
        'author':        r'BY: \g<subst>',
        }

    from rst import rst_code
    CODE['st'] = rst_code
    LIST['st'] = {
        'itemize':
        {'begin': '', 'item': '-', 'end': ''},

        'enumerate':
        {'begin': '', 'item': '%d.', 'end': ''},

        'description':
        {'begin': '', 'item': '%s -- ', 'end': ''},

        'separator': '',
        }
    from common import DEFAULT_ARGLIST
    ARGLIST['st'] = DEFAULT_ARGLIST
